
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef ivmob_TCLSERV_CLIENT_ERROR_H
#define ivmob_TCLSERV_CLIENT_ERROR_H

#include <server/ivmobError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum ivmob_error {
	E_ivmob_OK					  			= 0,

	/* module errors */
	E_ivmob_TRACKING_ON                    = S_ivmob_TRACKING_ON,
	E_ivmob_BAD_CMD_PARAMETERS             = S_ivmob_BAD_CMD_PARAMETERS,
	E_ivmob_CANNOT_WRITE_FILE              = S_ivmob_CANNOT_WRITE_FILE,
	E_ivmob_CANNOT_OPEN_FILE               = S_ivmob_CANNOT_OPEN_FILE,
	E_ivmob_CANNOT_READ_POSTER             = S_ivmob_CANNOT_READ_POSTER,
	E_ivmob_GYRO_ERROR                     = S_ivmob_GYRO_ERROR,
	E_ivmob_MOTORS_OFF                     = S_ivmob_MOTORS_OFF,
	E_ivmob_CMD_STOP_TRACK                 = S_ivmob_CMD_STOP_TRACK,
	E_ivmob_BAD_REF                        = S_ivmob_BAD_REF,
	E_ivmob_POSTER_NOT_FOUND               = S_ivmob_POSTER_NOT_FOUND,
	E_ivmob_MANUAL_MODE                    = S_ivmob_MANUAL_MODE,
	E_ivmob_EMERGENCY_STOP                 = S_ivmob_EMERGENCY_STOP,
	E_ivmob_WAIT_RESET                     = S_ivmob_WAIT_RESET,
	E_ivmob_IVMOBLIB_ERROR                 = S_ivmob_IVMOBLIB_ERROR,


	/* std errors */
	E_ivmob_ACTIVITY_INTERRUPTED           = S_ivmob_stdGenoM_ACTIVITY_INTERRUPTED,
	E_ivmob_TOO_MANY_ACTIVITIES            = S_ivmob_stdGenoM_TOO_MANY_ACTIVITIES,
	E_ivmob_ACTIVITY_FAILED                = S_ivmob_stdGenoM_ACTIVITY_FAILED,
	E_ivmob_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_ivmob_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_ivmob_UNKNOWN_ACTIVITY               = S_ivmob_stdGenoM_UNKNOWN_ACTIVITY,
	E_ivmob_FORBIDDEN_ACTIVITY_TRANSITION  = S_ivmob_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_ivmob_SYSTEM_ERROR                   = S_ivmob_stdGenoM_SYSTEM_ERROR,
	E_ivmob_ACTIVITY_ALREADY_ENDED         = S_ivmob_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_ivmob_WAIT_INIT_RQST                 = S_ivmob_stdGenoM_WAIT_INIT_RQST,
	E_ivmob_CONTROL_CODEL_ERROR            = S_ivmob_stdGenoM_CONTROL_CODEL_ERROR,
	E_ivmob_EXEC_TASK_SUSPENDED            = S_ivmob_stdGenoM_EXEC_TASK_SUSPENDED,
	E_ivmob_BAD_BLOCK_TYPE                 = S_ivmob_stdGenoM_BAD_BLOCK_TYPE,
	E_ivmob_BAD_POSTER_TYPE                = S_ivmob_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum ivmob_error ivmob_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int ivmob_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the ivmob context.
 *
 * Returns NULL in case of failure
 */
const char* ivmob_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
